ST.quiz = function() {
    function get_filter_field_values(fields) {
        var result = [],
            field;
        fields.each(function(index, element) {
            field = $(element);
            if (field.is('select') || field.is('input:checked')) {
                result.push({
                    name: field.attr('name'),
                    value: field.val()
                });
            }
        });
        return result;
    };
    function getInputSelection(el) {
        var start = 0,
            end = 0,
            normalizedValue,
            range,
            textInputRange,
            len,
            endRange;
        if (typeof el.selectionStart == "number" &&
            typeof el.selectionEnd == "number") {
            start = el.selectionStart;
            end = el.selectionEnd;
        } else {
            range = document.selection.createRange();
            if (range && range.parentElement() == el) {
                len = el.value.length;
                normalizedValue = el.value.replace(/\r\n/g, "\n");
                // Create a working TextRange that lives only in the input
                textInputRange = el.createTextRange();
                textInputRange.moveToBookmark(range.getBookmark());
                // Check if the start and end of the selection are at the very end
                // of the input, since moveStart/moveEnd doesn't return what we want
                // in those cases
                endRange = el.createTextRange();
                endRange.collapse(false);
                if (textInputRange.compareEndPoints("StartToEnd", endRange) > -1) {
                    start = end = len;
                } else {
                    start = -textInputRange.moveStart("character", -len);
                    start += normalizedValue.slice(0, start).split("\n").length - 1;
                    if (textInputRange.compareEndPoints("EndToEnd", endRange) > -1) {
                        end = len;
                    } else {
                        end = -textInputRange.moveEnd("character", -len);
                        end += normalizedValue.slice(0, end).split("\n").length - 1;
                    }
                }
            }
        }
        return {
            start: start,
            end: end
        };
    };
    function image_directive(link) {
        var link = $(link),
            directive = [
                '.. image:: ' + link.attr('href'),
                '   :width: 500px',
                '   :alt: ' + link.attr('title'),
            ];
        return directive.join('\n');
    };
    return {
        get_filter_field_values: get_filter_field_values,
        insert_image: function(link) {
            var link = $(link),
                link_item_url = link.attr('class'),
                el = $('#form-widgets-body'),
                value,
                position;
            el.focus();
            position = getInputSelection(el.get(0));
            value = el.val().substring(0, position.start) + image_directive(link) + el.val().substring(position.end, el.val().length);
            el.val(value);
            el.selectRange(position.start, position.start);
            $.ajax(link_item_url);
            $('#form-widgets-image').val(link.attr('id'));
            return ST.dialogs.close(link);
        },
        copy_menu_options: function(menu) {
            var result = [];
            $(menu).find('option').each(function(i, e) {
                result.push($(e).clone());
            });
            return result;
        },
        filter_menu_options: function(menu, options, value, novalue_token) {
            $(options).each(function(i, e) {
                if ($(e).attr('value').startsWith(value) ||
                    $(e).attr('value') == novalue_token) {
                    menu.append($(e));
                }
            });
        }
    };
}();
$(document).ready(function() {
    if (typeof String.prototype.startsWith != 'function') {
        String.prototype.startsWith = function (str){
            return this.slice(0, str.length) == str;
        };
    }
    var items_container = $('table.quiz-items-table').closest('.content');
    $('input.datetime-field').datetimepicker({
        dateFormat: 'yy-mm-dd',
        timeFormat: 'hh:mm:ss',
        yearRange: 'c-20:c+10',
        changeMonth: true,
        changeYear: true
    });
    items_container.on('change', '.item-sort', function() {
        var container = $(this).closest('form').parent(),
            data = [{name: 'changePosition', value: $(this).attr('name')}];
        ST.table.on_form_submit(container.attr('id'), null, data);
    });
});
$.fn.selectRange = function(start, end) {
    return this.each(function() {
        if (this.setSelectionRange) {
            this.focus();
            this.setSelectionRange(start, end);
        } else if (this.createTextRange) {
            var range = this.createTextRange();
            range.collapse(true);
            range.moveEnd('character', end);
            range.moveStart('character', start);
            range.select();
        }
    });
};
