#
# SchoolTool - common information systems platform for school administration
# Copyright (c) 2012 Shuttleworth Foundation,
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License along
# with this program; if not, write to the Free Software Foundation, Inc.,
# 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
#
"""
SchoolTool Quiz preferences.
"""

from persistent import Persistent
from zope.annotation.interfaces import IAnnotations
from zope.component import adapter
from zope.interface import implements, implementer

from schooltool.app.interfaces import ISchoolToolApplication
from schooltool.quiz import interfaces


PREFERENCES_KEY = 'schooltool.quiz.quiz'


class Rule(Persistent):

    implements(interfaces.IRule)

    level = number_correct = total_taken = out_of = None

class ApplicationPreferences(Persistent):

    implements(interfaces.IApplicationPreferences)

    mathjax_help = None

    skill_rules = None

    save_time = 10

@adapter(ISchoolToolApplication)
@implementer(interfaces.IApplicationPreferences)
def getApplicationPreferences(app):
    annotations = IAnnotations(app)
    try:
        return annotations[PREFERENCES_KEY]
    except KeyError:
        annotations[PREFERENCES_KEY] = ApplicationPreferences()
        annotations[PREFERENCES_KEY].__parent__ = app
        return annotations[PREFERENCES_KEY]
