#
# SchoolTool - common information systems platform for school administration
# Copyright (c) 2012 Shuttleworth Foundation,
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License along
# with this program; if not, write to the Free Software Foundation, Inc.,
# 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
#
"""
SchoolTool Quiz relationships.
"""

from schooltool.relationship import URIObject, RelationshipSchema


URIQuizItems = URIObject(
    'http://schooltool.org/ns/quiz/quiz_items',
    'Quiz items',
    'Quiz items for this quiz.')


URIQuizEditors = URIObject(
    'http://schooltool.org/ns/quiz/quiz_editors',
    'Quiz editors',
    'Quiz editors for this quiz.')


URIQuizImageEditors = URIObject(
    'http://schooltool.org/ns/quiz/quiz_image_editors',
    'Quiz image editors',
    'Quiz image editors for this quiz image.')


URIQuizDeployedQuizzes = URIObject(
    'http://schooltool.org/ns/quiz/quiz_deployed_quizzes',
    'Quiz deployed quizzes',
    'Deployed quizzes for this quiz.')


URIDeployedQuizItems = URIObject(
    'http://schooltool.org/ns/quiz/deployed_quiz_items',
    'Deployed quiz items',
    'Quiz items for this deployed quiz.')


URIQuizItemImages = URIObject(
    'http://schooltool.org/ns/quiz/quiz_item_images',
    'Quiz item images',
    'Quiz images for this quiz item.')


URIQuiz = URIObject(
    'http://schooltool.org/ns/quiz/quiz',
    'Quiz',
    'A quiz.')


URIQuizItem = URIObject(
    'http://schooltool.org/ns/quiz/quiz_item',
    'Quiz item',
    'A quiz item.')


URIDeployedQuiz = URIObject(
    'http://schooltool.org/ns/quiz/deployed_quiz',
    'Deployed quiz',
    'A deployed quiz.')


URIQuizEditor = URIObject(
    'http://schooltool.org/ns/quiz/quiz_editor',
    'Quiz editor',
    'A quiz editor.')


URIQuizImageEditor = URIObject(
    'http://schooltool.org/ns/quiz/quiz_image_editor',
    'Quiz image editor',
    'A quiz image editor.')


URIQuizImage = URIObject(
    'http://schooltool.org/ns/quiz/quiz_image',
    'Quiz image',
    'A quiz image.')


QuizItems = RelationshipSchema(
    URIQuizItems,
    quiz=URIQuiz,
    item=URIQuizItem)


QuizEditors = RelationshipSchema(
    URIQuizEditors,
    quiz=URIQuiz,
    editor=URIQuizEditor)


QuizImageEditors = RelationshipSchema(
    URIQuizImageEditors,
    image=URIQuizImage,
    editor=URIQuizImageEditor)


QuizDeployedQuizzes = RelationshipSchema(
    URIQuizDeployedQuizzes,
    quiz=URIQuiz,
    deployed=URIDeployedQuiz)


DeployedQuizItems = RelationshipSchema(
    URIDeployedQuizItems,
    deployed=URIDeployedQuiz,
    item=URIQuizItem)


QuizItemImages = RelationshipSchema(
    URIQuizItemImages,
    image=URIQuizImage,
    item=URIQuizItem)
