#
# SchoolTool - common information systems platform for school administration
# Copyright (c) 2012 Shuttleworth Foundation,
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License along
# with this program; if not, write to the Free Software Foundation, Inc.,
# 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
#
"""
SchoolTool Quiz security.
"""

from schooltool.course.interfaces import IInstructor
from schooltool.person.interfaces import IPerson
from schooltool.securitypolicy.crowds import ConfigurableCrowd


class EditorsCrowd(ConfigurableCrowd):

    def contains(self, principal):
        person = IPerson(principal, None)
        if person is not None:
            return person in self.context.editors
        return False


class QuizInstructorsCrowd(ConfigurableCrowd):

    def contains(self, principal):
        person = IPerson(principal, None)
        if person is not None:
            return bool(IInstructor(person).sections())
        return False
